﻿using Monitor.CsHtml.MonitorWCFReference;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media.Imaging;

namespace Monitor.CsXAML
{
    public sealed partial class MainPage : Page
    {
        DispatcherTimer dt;

        public MainPage()
        {
            this.InitializeComponent();

            dt = new DispatcherTimer();
            dt.Interval = new TimeSpan(0, 0, 2);
            dt.Tick += Tick;
            dt.Start();
        }

        private void Tick(object sender, object e)
        {
            GetInfos();
        }

        async void GetInfos()
        {
            try
            {
                MonitorClient client = new MonitorClient(new BasicHttpBinding(), new EndpointAddress(new Uri(@"http://localhost:8732/Monitor.WCF/Monitor")));
                var iinfo = await client.GetInfosAsync();
                MonitorInfos info = iinfo.Body.GetInfosResult;
                if (info == null)
                {
                    return;
                }
                customersGrid.Children.Clear();
                int row = 0;
                foreach (var c in info.Infos)
                {
                    if (customersGrid.RowDefinitions.Count <= row)
                    {
                        customersGrid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(1, GridUnitType.Auto) });
                    }
                    while (customersGrid.ColumnDefinitions.Count <= c.AliveStatus.Length)
                    {
                        customersGrid.ColumnDefinitions.Add(new ColumnDefinition() { Width = new GridLength(1, GridUnitType.Auto) });
                    }

                    TextBlock tb = new TextBlock() { Text = c.Customer };
                    Grid.SetRow(tb, row);
                    customersGrid.Children.Add(tb);

                    int column = 1;
                    foreach (var aliveStatus in c.AliveStatus)
                    {
                        TextBlock img = new TextBlock() { Text = aliveStatus.Status };
                        Grid.SetColumn(img, column++);
                        Grid.SetRow(img, row);
                        customersGrid.Children.Add(img);
                    }
                    row++;
                }
                if (customersGrid.RowDefinitions.Last().Height.GridUnitType != GridUnitType.Star)
                {
                    customersGrid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(1, GridUnitType.Star) });
                }
            }
            catch (Exception ex)
            {
            }
        }
    }
}
