﻿using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Web;
using System.Collections.Generic;
using System;
using System.Runtime.Serialization;

namespace Monitor.WCF
{
    [Serializable]
    [DataContract]
    public class AliveInfo
    {
        [DataMember]
        public string PackageName { get; set; }
        [DataMember]
        public string Status { get; set; }
        [DataMember]
        public string Message { get; set; }
    }

    [Serializable]
    [DataContract]
    public class LoadedScenarioInfo
    {
        [DataMember]
        public string UserName { get; set; }
        [DataMember]
        public Guid Guid { get; set; }
        [DataMember]
        public string LastAccess { get; set; }
        [DataMember]
        public string SessionName { get; set; }
    }

    [Serializable]
    [DataContract]
    public class LoadedScenario
    {
        [DataMember]
        public string Name1 { get; set; }
        [DataMember]
        public string Name2 { get; set; }
        [DataMember]
        public List<LoadedScenarioInfo> Scenarios { get; set; }
    }

    [Serializable]
    [DataContract]
    public class MonitorInfo
    {
        [DataMember]
        public string Environment { get; set; }
        [DataMember]
        public string Customer { get; set; }
        [DataMember]
        public List<AliveInfo> AliveStatus { get; set; }
        [DataMember]
        public List<LoadedScenario> LoadedScenarios { get; set; }
        [DataMember]
        public Int64 MemoryService1 { get; set; }
        [DataMember]
        public Int64 MemoryService2 { get; set; }
        [DataMember]
        public Int64 MemoryService3 { get; set; }
    }

    [Serializable]
    [DataContract]
    public class MonitorInfos
    {
        [DataMember]
        public Int64 TookMs;
        [DataMember]
        public string LastUpdate;
        [DataMember]
        public List<MonitorInfo> Infos;
    }

    [ServiceContract]
    [XmlSerializerFormat]
    public interface IMonitor
    {
        [OperationContract]
        MonitorInfos GetInfos();
    }
}
