﻿using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Web;
using System.Collections.Generic;
using System;
using System.Xml.Serialization;
using System.IO;
using System.Diagnostics;
using System.Threading.Tasks;
using System.Collections.Concurrent;

namespace Monitor.WCF
{
    public class Monitor : IMonitor
    {

        static Monitor()
        {
        }

        public MonitorInfos GetInfos()
        {
            return new MonitorInfos()
            {
                LastUpdate = DateTime.Now.ToShortTimeString(),
                TookMs = 100,
                Infos = new List<MonitorInfo>()
                {
                    new MonitorInfo()
                        {
                             Customer = "test1",
                             Environment = "test1",
                             MemoryService1 = 0,
                             MemoryService2 = 0,
                             MemoryService3 = 0,
                             AliveStatus = new List<AliveInfo>()
                             {
                                new AliveInfo() { Message = string.Empty, PackageName = "package1", Status = "Alive" },
                                new AliveInfo() { Message = string.Empty, PackageName = "package2", Status = "Alive" },
                                new AliveInfo() { Message = string.Empty, PackageName = "package3", Status = "Alive" },
                                new AliveInfo() { Message = string.Empty, PackageName = "package4", Status = "Unknown" }
                             },
                             LoadedScenarios = new List<LoadedScenario>()
                             {
                                 new LoadedScenario()
                                    {
                                        Name1 = "Name1a",
                                        Name2 = "Name2a",
                                        Scenarios = new List<LoadedScenarioInfo>()
                                            {
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                            }
                                    },
                                new LoadedScenario()
                                    {
                                        Name1 = "Name1b",
                                        Name2 = "Name2b",
                                        Scenarios = new List<LoadedScenarioInfo>()
                                            {
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                                new LoadedScenarioInfo() { Guid = Guid.NewGuid(), LastAccess = DateTime.Now.ToShortTimeString(), SessionName = "session1", UserName = "meUser" },
                                            }
                                    }
                             }
                        }
                }
            };
        }
    }
}
